// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 Contains information about the current status of a webhook.

 SeeAlso Telegram Bot API Reference:
 [WebhookInfo](https://core.telegram.org/bots/api#webhookinfo)
 */
public final class WebhookInfo: Codable {

    /// Custom keys for coding/decoding `WebhookInfo` struct
    enum CodingKeys: String, CodingKey {
        case url = "url"
        case hasCustomCertificate = "has_custom_certificate"
        case pendingUpdateCount = "pending_update_count"
        case lastErrorDate = "last_error_date"
        case lastErrorMessage = "last_error_message"
        case maxConnections = "max_connections"
        case allowedUpdates = "allowed_updates"
    }

    /// Webhook URL, may be empty if webhook is not set up
    public var url: String

    /// True, if a custom certificate was provided for webhook certificate checks
    public var hasCustomCertificate: Bool

    /// Number of updates awaiting delivery
    public var pendingUpdateCount: Int

    /// Optional. Unix time for the most recent error that happened when trying to deliver an update via webhook
    public var lastErrorDate: Int?

    /// Optional. Error message in human-readable format for the most recent error that happened when trying to deliver an update via webhook
    public var lastErrorMessage: String?

    /// Optional. Maximum allowed number of simultaneous HTTPS connections to the webhook for update delivery
    public var maxConnections: Int?

    /// Optional. A list of update types the bot is subscribed to. Defaults to all update types
    public var allowedUpdates: [String]?


    public init (url: String, hasCustomCertificate: Bool, pendingUpdateCount: Int, lastErrorDate: Int? = nil, lastErrorMessage: String? = nil, maxConnections: Int? = nil, allowedUpdates: [String]? = nil) {
        self.url = url
        self.hasCustomCertificate = hasCustomCertificate
        self.pendingUpdateCount = pendingUpdateCount
        self.lastErrorDate = lastErrorDate
        self.lastErrorMessage = lastErrorMessage
        self.maxConnections = maxConnections
        self.allowedUpdates = allowedUpdates
    }
}
